<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-fit flex flex-col text-white text-base">
  <div *ngIf="!_params || _params.length <= 0" class="flex items-center leading-none">
    <div [ngClass]="{ 'pt-2.5': !editMode }" class="text-text-300 font-semibold">No Parameters</div>
    <p-button
      *ngIf="editMode"
      label="Edit"
      icon="pi pi-pencil"
      [link]="true"
      size="small"
      (click)="addParam()"
      [disabled]="loading"
    ></p-button>
  </div>
  <div
    *ngIf="_params && _params.length > 0"
    class="w-full"
    [ngClass]="{ 'bg-white bg-opacity-5 rounded-sm': editParams }"
  >
    <div *ngFor="let param of _params; index as i; trackBy: trackByFn" class="w-full">
      <div class="flex gap-2 border-b border-white border-opacity-10 py-4 px-4">
        <div *ngIf="editParams" class="flex items-center gap-2 w-full">
          <input
            #inputs
            pInputText
            type="text"
            class="p-inputtext-sm"
            placeholder="Key"
            [(ngModel)]="_params[i].value"
            [disabled]="loading"
          />
          <div class="w-24 pr-4 flex justify-end">
            <p-tag *ngIf="param.isNew" severity="info" value="New"></p-tag>
          </div>
          <div class="flex justify-end">
            <p-button
              icon="fa fa-trash-can"
              severity="danger"
              [text]="true"
              [disabled]="loading"
              size="small"
              (click)="removeParam(i)"
            ></p-button>
          </div>
        </div>
        <div *ngIf="!editParams" class="flex items-center justify-between gap-4 w-full">
          <div class="custom-min-width">{{ param.value }}:</div>
          <input pInputText type="text" class="p-inputtext-sm" placeholder="Value" [(ngModel)]="values[i]" />
        </div>
      </div>
    </div>
    <div *ngIf="editParams" class="px-4 pb-4 border-b border-opacity-10 border-white">
      <div
        *ngIf="editParams"
        (click)="addParam()"
        class="h-8 bg-dialogGrey rounded-sm flex items-center justify-center text-secondary-900 mt-4"
        [ngClass]="{ 'cursor-pointer': !loading, 'opacity-60': loading }"
      >
        <i class="pi pi-plus"></i>
      </div>
    </div>
    <div class="py-2 w-full flex gap-2 justify-between">
      <div *ngIf="editParams" class="w-full">
        <div class="w-full flex items-center justify-end pr-4 mt-2 pb-2">
          <p-button
            label="Cancel"
            icon="pi pi-times"
            severity="danger"
            [text]="true"
            size="small"
            (click)="cancel()"
            [disabled]="loading"
          ></p-button>
          <p-button
            label="Save"
            icon="pi pi-save"
            severity="success"
            [outlined]="true"
            size="small"
            (click)="save()"
            [loading]="loading"
          ></p-button>
        </div>
      </div>
      <div *ngIf="editMode && !editParams">
        <p-button
          label="Edit"
          icon="pi pi-pencil"
          severity="primary"
          [text]="true"
          size="small"
          (click)="editParams = true"
        ></p-button>
      </div>
    </div>
  </div>
</div>
